# std::__debug::unordered_set< _Value, _Hash, _Pred, _Alloc > Class Template Reference

Class std::unordered_set with safety/checking/debug instrumentation. More...

Inheritance diagram for std::__debug::unordered_set< _Value, _Hash, _Pred, _Alloc >:
[legend]

List of all members.

## Public Types

- typedef _Base::allocator_type allocator_type
- typedef
  __gnu_debug::_Safe_iterator
  < typename
  _Base::const_iterator,
  unordered_set > const_iterator
- typedef _Base::hasher hasher
- typedef
  __gnu_debug::_Safe_iterator
  < typename _Base::iterator,
  unordered_set > iterator
- typedef _Base::key_equal key_equal
- typedef _Base::key_type key_type
- typedef _Base::size_type size_type
- typedef _Base::value_type value_type

## Public Member Functions

- unordered_set (size_type __n=10, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
- template<typename _InputIterator > unordered_set (_InputIterator __f, _InputIterator __l, size_type __n=10, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
- unordered_set (const _Base &__x)
- unordered_set (unordered_set &&__x)
- unordered_set (const unordered_set &__x)
- unordered_set (initializer_list< value_type > __l, size_type __n=10, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
- _Base & _M_base ()
- const _Base & _M_base () const
- void _M_invalidate_all () const
- void _M_invalidate_if (_Predicate __pred)
- void _M_transfer_iter (const _Safe_iterator< _Iterator, unordered_set< _Value, _Hash, _Pred, _Alloc > > &__x)
- iterator begin ()
- const_iterator begin () const
- const_iterator cbegin () const
- const_iterator cend () const
- void clear ()
- const_iterator end () const
- iterator end ()
- std::pair< iterator, iterator > equal_range (const key_type &__key)
- std::pair< const_iterator,
  const_iterator > equal_range (const key_type &__key) const
- size_type erase (const key_type &__key)
- iterator erase (const_iterator __it)
- iterator erase (const_iterator __first, const_iterator __last)
- iterator find (const key_type &__key)
- const_iterator find (const key_type &__key) const
- iterator insert (const_iterator, const value_type &__obj)
- std::pair< iterator, bool > insert (const value_type &__obj)
- void insert (std::initializer_list< value_type > __l)
- template<typename _InputIterator > void insert (_InputIterator __first, _InputIterator __last)
- unordered_set & operator= (unordered_set &&__x)
- unordered_set & operator= (initializer_list< value_type > __l)
- unordered_set & operator= (const unordered_set &__x)
- void swap (unordered_set &__x)

## Public Attributes

- _Safe_iterator_base * _M_const_iterators
- _Safe_iterator_base * _M_iterators
- unsigned int _M_version

## Protected Member Functions

- void _M_detach_all ()
- void _M_detach_singular ()
- __gnu_cxx::__mutex & _M_get_mutex () throw ()
- void _M_revalidate_singular ()
- void _M_swap (_Safe_sequence_base &__x)

## Detailed Description

### template<typename _Value, typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>
class std::__debug::unordered_set< _Value, _Hash, _Pred, _Alloc >

Class std::unordered_set with safety/checking/debug instrumentation.

Definition at line 50 of file debug/unordered_set.

## Member Function Documentation

void __gnu_debug::_Safe_sequence_base::_M_detach_all | ( |  | ) | `[protected, inherited]`

Detach all iterators, leaving them singular.

void __gnu_debug::_Safe_sequence_base::_M_detach_singular | ( |  | ) | `[protected, inherited]`

Detach all singular iterators.

Postcondition:
  for all iterators i attached to this sequence, i->_M_version == _M_version.

__gnu_cxx::__mutex& __gnu_debug::_Safe_sequence_base::_M_get_mutex | ( |  | ) | throw ()`[protected, inherited]`

For use in _Safe_sequence.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

void __gnu_debug::_Safe_sequence_base::_M_invalidate_all | ( |  | ) | const`[inline, inherited]`

Invalidates all iterators.

Definition at line 215 of file safe_base.h.

void __gnu_debug::_Safe_sequence< unordered_set< _Value, _Hash, _Pred, _Alloc > >::_M_invalidate_if | ( | _Predicate | __pred | ) | `[inherited]`

Invalidates all iterators `x` that reference this sequence, are not singular, and for which `pred(x)` returns `true`. The user of this routine should be careful not to make copies of the iterators passed to `pred`, as the copies may interfere with the invalidation.

void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular | ( |  | ) | `[protected, inherited]`

Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reason, such as an exception, need to become valid again).

void __gnu_debug::_Safe_sequence_base::_M_swap | ( | _Safe_sequence_base & | __x | ) | `[protected, inherited]`

Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

void __gnu_debug::_Safe_sequence< unordered_set< _Value, _Hash, _Pred, _Alloc > >::_M_transfer_iter | ( | const _Safe_iterator< _Iterator, unordered_set< _Value, _Hash, _Pred, _Alloc > > & | __x | ) | `[inherited]`

Transfers all iterators that reference this memory location to this sequence from whatever sequence they are attached to.

## Member Data Documentation

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators `[inherited]`

The list of constant iterators that reference this container.

Definition at line 166 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators `[inherited]`

The list of mutable iterators that reference this container.

Definition at line 163 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

unsigned int __gnu_debug::_Safe_sequence_base::_M_version `[mutable, inherited]`

The container version number. This number may never be 0.

Definition at line 169 of file safe_base.h.

The documentation for this class was generated from the following file:

- debug/unordered_set